Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.gradle.tooling
[Java] Interface ProjectConnection

    public interface ProjectConnection

Represents a long-lived connection to a Gradle project.

## Thread safety

All implementations of `GradleConnection` are thread-safe, and may be shared by any number of threads.

All notifications from a given `GradleConnection` instance are delivered by a single thread at a time. Note, however, that the delivery thread may change over time.

Method Summary
`void` | `close()` Closes this connection.
`T` | `getModel(java.lang.Class viewType)` Fetches a snapshot of the model for this project.
`void` | `getModel(java.lang.Class viewType, ResultHandler handler)` Fetches a snapshot of the model for this project asynchronously.

Method Detail

### close

    public void close()

  Closes this connection. Blocks until the close is complete. Once this method has returned, no more notifications will be delivered by any threads.

### getModel

    public T getModel(java.lang.Class viewType)

  Fetches a snapshot of the model for this project. This method blocks until the model is available.
  throws:
    UnsupportedVersionException When the target Gradle version does not support the given model.
  throws:
    GradleConnectionException On some failure to communicate with Gradle.
  throws:
    IllegalStateException When this connection has been closed or is closing.
  Parameters:
    `viewType` - The model type.
    `` - The model type.
  Returns:
    The model.

### getModel

    public void getModel(java.lang.Class viewType, ResultHandler handler)

  Fetches a snapshot of the model for this project asynchronously. This method return immediately, and the result of the operation is passed to the supplied result handler.
  throws:
    IllegalStateException When this connection has been closed or is closing.
  Parameters:
    `viewType` - The model type.
    `handler` - The handler to pass the result to.
    `` - The model type.

Groovy Documentation